unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  HPVControl, ExtCtrls, MSXML, StdCtrls, DB, DBClient, Menus, Grids,
  DBGrids, ComCtrls;

const
  WM_AJOUTENOEUDS = WM_USER + 1;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Home1: TMenuItem;
    HPVControl: THPVControl;
    Folder: TImage;
    FolderOpened: TImage;
    ImageRoot: TImage;
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Home1Click(Sender: TObject);
    procedure HPVControlDblClick(Sender: TObject);
  private
    procedure CreeNoeuds;
    procedure AjouteNoeuds(var Message: TMessage); message WM_AJOUTENOEUDS;
  public
    { Dclarations publiques }
  end;

  THPVNodeImage = class(THPVNode)
  public
    procedure Paint(Canvas: TCanvas; MouseOver: Boolean); override;
    procedure SetBounds(Canvas: TCanvas; var Rect: TRect); override;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.AjouteNoeuds(var Message: TMessage);
begin
  Application.ProcessMessages;
  CreeNoeuds;
end;

procedure TForm1.CreeNoeuds;

  class function OpenXMLDocument(const FileName: string): IXMLDOMDocument;
  var
    Error: IXMLDOMParseError;
  begin
    Result := CoDOMDocument.Create;

    if not Result.load(FileName) then
    begin
      Error := Result.parseError;
      raise Exception.CreateFmt('Parse error %x at %s:%d: %s',
        [Error.errorCode, FileName, Error.line, Error.reason]);
    end;
  end;

var
  Doc: IXMLDOMDocument;

  procedure AjouteNoeuds(XMLNode: IXMLDOMNode; Node: THPVNode);
  var
    I: Integer;
    N: THPVNode;
  begin
    if XMLNode.nodeType = NODE_ELEMENT then
    begin
      Node.Caption := XMLNode.nodeName;
      for I := 0 to XMLNode.childNodes.length-1 do
        if XMLNode.childNodes.item[I].nodeType = NODE_ELEMENT then
        begin
          if Copy(XMLNode.childNodes.item[I].nodeName, 1, 4) = 'CAIS' then
            N := THPVNodeImage.Create
          else
            N := THPVNode.Create;
          N.Caption := XMLNode.childNodes.item[I].nodeName;
          Node.AddChild(N);

          HPVControl.HPVPaint;

          AjouteNoeuds(XMLNode.childNodes.item[I], N);
        end;
    end;
  end;

begin
  Doc := OpenXMLDocument('test.xml');

  HPVControl.RootNode := THPVNodeImage.Create;
  AjouteNoeuds(Doc.documentElement, HPVControl.RootNode);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  HPVControl.RootNode.Free;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  PostMessage(Handle, WM_AJOUTENOEUDS, 0, 0);
end;

procedure TForm1.Home1Click(Sender: TObject);
begin
  HPVControl.Home;
end;

procedure TForm1.HPVControlDblClick(Sender: TObject);
var
  N: THPVNode;
begin
  N := HPVControl.GetSelected(HPVControl.ScreenToClient(Mouse.CursorPos));
  if N <> nil then
    ShowMessage(N.Caption);
end;


{ THPVNodeImage }

procedure THPVNodeImage.Paint(Canvas: TCanvas; MouseOver: Boolean);
begin
  Canvas.Brush.Style := bsClear;

  Canvas.Font.Style := Canvas.Font.Style - [fsBold];

  if not MouseOver then
  begin
    if Self = Form1.HPVControl.RootNode then
      Canvas.Draw(Point.X, Point.Y, Form1.ImageRoot.Picture.Graphic)
    else
      Canvas.Draw(Point.X, Point.Y, Form1.Folder.Picture.Graphic)
  end
  else
    if Self <> Form1.HPVControl.RootNode then
      Canvas.Draw(Point.X, Point.Y, Form1.FolderOpened.Picture.Graphic);
  Canvas.TextOut(Point.X + Form1.Folder.Picture.Graphic.Width,
    Point.Y + Form1.Folder.Picture.Graphic.Height,
    Caption
  );
end;

procedure THPVNodeImage.SetBounds(Canvas: TCanvas; var Rect: TRect);
begin
  Rect := Classes.Rect(Point.X, Point.Y,
    Point.X + Form1.Folder.Picture.Graphic.Width,
    Point.Y + Form1.Folder.Picture.Graphic.Height);
end;

end.
